/**
 * React Blessed Dependency Injection
 * ===================================
 *
 * Injecting the renderer's needed dependencies into React's internals.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = inject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactLibReactInjection = require('react/lib/ReactInjection');

var _reactLibReactInjection2 = _interopRequireDefault(_reactLibReactInjection);

var _reactLibReactComponentEnvironment = require('react/lib/ReactComponentEnvironment');

var _reactLibReactComponentEnvironment2 = _interopRequireDefault(_reactLibReactComponentEnvironment);

var _ReactBlessedReconcileTransaction = require('./ReactBlessedReconcileTransaction');

var _ReactBlessedReconcileTransaction2 = _interopRequireDefault(_ReactBlessedReconcileTransaction);

var _ReactBlessedComponent = require('./ReactBlessedComponent');

var _ReactBlessedComponent2 = _interopRequireDefault(_ReactBlessedComponent);

var _ReactBlessedTextComponent = require('./ReactBlessedTextComponent');

var _ReactBlessedTextComponent2 = _interopRequireDefault(_ReactBlessedTextComponent);

var _blessedLibEvents = require('blessed/lib/events');

var _blessedLibEvents2 = _interopRequireDefault(_blessedLibEvents);

function inject() {

  /**
   * React-related injection.
   */
  _reactLibReactInjection2['default'].NativeComponent.injectGenericComponentClass(_ReactBlessedComponent2['default']);

  _reactLibReactInjection2['default'].NativeComponent.injectTextComponentClass(_ReactBlessedTextComponent2['default']);

  _reactLibReactInjection2['default'].Updates.injectReconcileTransaction(_ReactBlessedReconcileTransaction2['default']);

  // NOTE: very dirty trick due to react@0.14-beta1's current state
  _reactLibReactComponentEnvironment2['default'].processChildrenUpdates = Function.prototype;

  /**
   * Overriding blessed event emitter.
   */
  var originalEmit = _blessedLibEvents2['default'].prototype.emit;

  _blessedLibEvents2['default'].prototype.onAny = function (fn) {
    this._any = fn;
    return this;
  };

  _blessedLibEvents2['default'].prototype.emit = function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (typeof this._any === 'function') this._any.apply(this, args);
    return originalEmit.apply(this, args);
  };

  _blessedLibEvents2['default'].prototype.offAny = function () {
    delete this._any;
    return this;
  };
}

module.exports = exports['default'];